unit FilePrg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,FileIo;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    CheckBoxCreate: TCheckBox;
    CheckBoxClose: TCheckBox;
    CheckBoxShouldExist: TCheckBox;
    Button3: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    CloseFName      : Boolean;
    CreateFName     : Boolean;
    ShouldExist     : Boolean;
    Procedure SetBooleans;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SetBooleans;

Begin
    CloseFName       := CheckBoxClose.Checked;
    CreateFName      := CheckBoxCreate.Checked;
    ShouldExist      := CheckBoxShouldExist.Checked;
End;

procedure TForm1.Button3Click(Sender: TObject);

Var
  Filvar, Filvar1 : File;
  FName           : String;

begin
  Fname := edit1.text;
  if FName='' then Fname:='Test.dat';
  FileExists(FName,Filvar,1,ReadWrite,DenyAll,True,False,False);
  FileExists(FName,Filvar1,1,ReadWrite,DenyAll,True,True,True);
  CloseFile(Filvar);
end;

procedure TForm1.Button1Click(Sender: TObject);

Var
  FName    : String;
  m_Result : Boolean;
  Filvar   : File;

begin
  If Edit1.Text<>'' Then
    Begin
      FName:=Edit1.Text;
      SetBooleans;
      m_Result:= FileExists(Fname,
                            Filvar,
                            1,
                            ReadWrite,
                            DenyAll,
                            CreateFName,
                            CloseFName,
                            ShouldExist);

      If CreateFName then
        Begin
          Case FileExistsResult of
             3 : OkBox('File : '+extractFileName(Fname)+
                               ' was created and was closed.',mtinformation);
             0 :
                Begin
                  Case CloseFName  of
                     False : OkBox('File : '+extractFileName(Fname)+
                                   ' was created or already exists and was left open.',mtinformation);
                     True  :  OkBox('File : '+extractFileName(Fname)+
                                    ' was created or already exists and was closed.',mtinformation);
                  End; // end of case CloseFName of;
                  if not CloseFName then closefile(filvar);
                End;
             // all other possiblities are handled by fileexists, because they
             // are errormessages is something is wrong.....
          End; // End of Case FileExistsresult of;
        End // end of if CreatFName=True;
      Else
        Case ShouldExist Of
          True  ,False :
              Case m_Result of
                False : OkBox('File : '+extractFileName(Fname)+
                              ' didn''t exist.',mtInformation);
                True  :
                  Case CloseFName Of
                    False :
                      Begin
                        OkBox('File : '+extractFileName(Fname)+
                              ' exists and was left open.',mtInformation);
                        if not CloseFName then CloseFile(Filvar);
                      End;
                    True : OkBox('File : '+extractFileName(Fname)+
                                 ' exists and was closed.',mtInformation);
                  End; //End of case CloseFName of;
              End; // End of Case m_Result of;
         End; //End of case ShouldExist of;
    End; //end of if CreatFName=False the else loop;
end;

end.


